if (typeof FD == "undefined" || !FD) {
	var FD = {};
}

var gContextMenu = null;

FD.open = function() {
    //setTimeout(FD.start, 1);
    //alert('Foxden is loading its frames...');
    FD.start();
}

FD.start = function() {
    open("chrome://foxden/content/foxden.xul", "Foxden", "chrome");
}

FD.main = function() {
    FD.the_manager = new FD.Manager();
}

CONTAINER_ID = "fd_main";
HELP_URL = "http://www.darkcoding.net/welcome-to-foxden/";

FD.Manager = function() {   // Constructor
    
    this.nextId = 1;
    this.elementStack = [];
    this.elementStack.push( document.getElementById(CONTAINER_ID) );
    this.activeBrowser = null;
    
    if (Util.getBoolPref('maximize')) {
        this.maximize();
    }
    
    this.createLayout();
    this.attachEventHandlers();
    
}

FD.Manager.prototype = {
    
    showContextMenu:
        function(event) {
            content = this.activeBrowser; // Yes a globlal. FF sets this for it's regular windows
            gContextMenu = new nsContextMenu(event.target, this.activeBrowser);
            return gContextMenu.shouldDisplay;
        },
    
    attachEventHandlers:
        function() {
            var _this = this;
            
            var layoutMenuitem = document.getElementById("fd_menu_layout");
            layoutMenuitem.addEventListener("command", function() {_this.onLayoutMenu()}, false);
            
            var resetMenuItem = document.getElementById("fd_menu_reset");
            resetMenuItem.addEventListener("command", function() {_this.onResetMenu()}, false);
            
            var helpMenuitem = document.getElementById("fd_menu_help");
            helpMenuitem.addEventListener("command", function() {_this.onHelpMenu()}, false);
        },
    
    onLayoutMenu:
        function() {
            var _this = this;
            openDialog(
                        'chrome://foxden/content/pref_layout.xul',
                        'Foxden layout configuration',
                        "",
                        function() {_this.updateLayout()}
                        );
        },
    
    onResetMenu:
        function() {
            var s = 'Reset the layout to what it was on first installation?';
            if (confirm(s)) {
                Util.clearPref('layout');
                Util.clearPref('maximize');
                this.updateLayout();
            }
        },
        
    onHelpMenu:
        function() {
            open(HELP_URL);
        },
        
    updateLayout:
        function() {
                        
            // Delete everything
            var container = document.getElementById(CONTAINER_ID);
            while (container.firstChild) {
                container.removeChild(container.firstChild);
            }
            
            // Re-create it
            this.createLayout();
        },
    
    maximize:
        function() {
            window.moveTo(0, 50);
            window.resizeTo(screen.availWidth, screen.availHeight);
            //window.maximize();
        },
    /*
    sizeTheBox:
        function() {
            var container = document.getElementById(CONTAINER_ID);
            container.resizeTo(screen.availWidth, screen.availHeight);
        },
    */    
    loadFile:
        function(filePath, textboxId) {
            var fileIn = FileIO.open(filePath);
            var fileData = FileIO.read(fileIn);
            var textbox = document.getElementById(textboxId);
            textbox.setAttribute('value', fileData);
            textbox.reset();
        },
        
    saveFile:
        function(filePath, textboxId) {
            var data = document.getElementById(textboxId).value;
            var fileOut = FileIO.open(filePath);
            FileIO.write(fileOut, data);
        },
        
    createLayout:
        function() {
            var _this = this;
            
            var layout = Util.getCharPref('layout');
            if (! layout) {
                this.onLayoutMenu();
                return;
            }
            
            var tokens = layout.split(/ |\n/);
            
            for (var i=0; i<tokens.length; i++) {
                var token = tokens[i];
                if ( token.length == 0 ) {
                    continue;
                }

                if (token == "rows") {
                    var element = document.createElement("vbox");
                    this.addAttributes(element);
                    this.elementStack.push(element);
                }
                else if (token == "columns") {
                    var element = document.createElement("hbox");
                    this.addAttributes(element);
                    this.elementStack.push(element);
                }
                else if (token == ":rows" || token == ":columns") {
                    var element = this.elementStack.pop();
                    var parent = this.elementStack.pop();
                    if ( ! parent ) { // something bad happened, bail
                        return;
                    }
                    
                    if ( parent.firstChild ) {
                        parent.appendChild( this.splitter() );
                    }
                    
                    parent.appendChild(element);
                    this.elementStack.push(parent);
                }
                else if ( token.indexOf("file://") == 0 ) {
                    var element = this.elementStack.pop();
                    if ( element.firstChild ) {
                        element.appendChild( this.splitter() );
                    }
                    element.appendChild( this.fileEditor(token) );
                    this.elementStack.push(element);
                }
                else {
                    var element = this.elementStack.pop();
                    if ( element.firstChild ) {
                        element.appendChild( this.splitter() );
                    }
                    
                    var browser = document.createElement("browser");
                    
                    browser.setAttribute("id", "fd_id"+ this.nextId++);
                    browser.setAttribute("src", token);
                    browser.setAttribute("flex", "1");
                    browser.setAttribute("type", "content");
                    browser.setAttribute("context", "contentAreaContextMenu");
                    browser.setAttribute("tooltip", "aHTMLTooltip");
                    
                    browser.addEventListener("mouseover", function(event) {_this.onMouseOver(event)}, false);
                    //browser.addEventListener("mouseout", function(event) {_this.onMouseOut(event)}, false);
                    browser.addEventListener("click", function(event) { return _this.onBrowserClick(event) }, false);
                    
                    element.appendChild(browser);
                    
                    this.elementStack.push(element);
                }
            }
            
        },
        
    onBrowserClick: // Some of this code copied from browser.js:contentAreaClick
        function(event) {
            
            if ( event.button != 0 ) {  // Only deal with left-click
                return true;
            }
            if (!event.isTrusted || event.getPreventDefault()) {
                return true;
            }

            // Get the 'a' that was clicked

            var target = event.target;
            var linkNode;
            
            if (target instanceof HTMLAnchorElement ||
                target instanceof HTMLAreaElement ||
                target instanceof HTMLLinkElement)
            {
                if (target.hasAttribute("href")) { linkNode = target; }
            }
            else {
                linkNode = event.originalTarget;
                while (linkNode && !(linkNode instanceof HTMLAnchorElement)) {
                  linkNode = linkNode.parentNode;
                }
                // <a> cannot be nested.  So if we find an anchor without an
                // href, there is no useful <a> around the target
                if (linkNode && !linkNode.hasAttribute("href")) {
                  linkNode = null;
                }
            }

            if (!linkNode) {
                return true;
            }
            
            if (!event.ctrlKey && !event.shiftKey &&
                !event.altKey && !event.metaKey)
            {
                target = linkNode.getAttribute("target");
                if (!target || target == "_content" || target  == "_main")   // IE uses _main, SeaMonkey uses _content, we support both
                {
                    // a regular link, let FF process as normal
                    return true;
                }
                else {
                    // A new window or tab
                    
                    var isOpenInTab = false;
                    var prefManager = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefBranch);
                    try {
                        isOpenInTab = (prefManager.getIntPref('browser.link.open_newwindow') == 3);
                    }
                    catch (e) { }
                    
                    if (isOpenInTab) {
                        event.preventDefault();
                        Util.openNewTab(linkNode.getAttribute('href'));
                        return false;
                    }
                    
                    return true;
                }
            }
            
            return true;
        },
        
    onMouseOver:
        function(event) {
            var node = event.target;
            while ( node && node.tagName != 'browser' ) {
                node = node.parentNode;
            }
            if ( node != null ) {
                this.activeBrowser = node;    
            }
            
        },
        
    addAttributes:
        function(element) {
            element.setAttribute("id", "fd_id"+ this.nextId++);
            element.setAttribute("flex", "1");
            element.setAttribute("persist", "height width");            
        },
        
    splitter:
        function() {
            var splitter = document.createElement("splitter");
            splitter.setAttribute("collapse", "none");
            splitter.appendChild( document.createElement("grippy") );
            return splitter;
        },
        
    fileEditor:
        function(localURL) {
            var _this = this;
            
            var vbox = document.createElement("vbox");
            vbox.setAttribute("id", "fd_id"+ this.nextId++);
            vbox.setAttribute("flex", "1");
            vbox.setAttribute("persist", "height width");

            var textbox = document.createElement("textbox");
            var textboxId = "fd_textbox"+ this.nextId++;
            textbox.setAttribute("id", textboxId);
            textbox.setAttribute("flex", "1");
            textbox.setAttribute("multiline", "true");

            var filePath = Util.urlToLocalFile(localURL);
            var fileIn = FileIO.open( filePath );
            var fileData = FileIO.read(fileIn);
            textbox.setAttribute('value', fileData);

            vbox.appendChild(textbox);
            
            var buttonBox = document.createElement("hbox");
            
            var revertButton = document.createElement("button");
            revertButton.setAttribute("id", "fd_revert"+ this.nextId++);
            revertButton.setAttribute("label", "Reload");
            buttonBox.appendChild(revertButton);
            
            var spacer = document.createElement("spacer");
            spacer.setAttribute("flex", "1");
            buttonBox.appendChild(spacer);
            
            var saveButton = document.createElement("button");
            saveButton.setAttribute("id", "fd_save"+ this.nextId++);
            saveButton.setAttribute("label", "Save");
            buttonBox.appendChild(saveButton);
            
            revertButton.addEventListener('command', function(){_this.loadFile(filePath, textboxId)}, false);
            saveButton.addEventListener('command', function(){_this.saveFile(filePath, textboxId)}, false);
            
            vbox.appendChild(buttonBox);
            
            return vbox;
        }
}

